SystemOrganization addCategory: #'XML-Parser-GTExtensions'!
SystemOrganization addCategory: 'XML-Parser-GTExtensions-Highlighting'!
SystemOrganization addCategory: 'XML-Parser-GTExtensions-Highlighting-Parser'!
SystemOrganization addCategory: 'XML-Parser-GTExtensions-Highlighting-Writer'!

!XMLDocument class methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/20/2015 22:19'!
gtExampleXmlNode
	<gtExample>
	^ XMLDOMParser parse: '<document><a></a><b></b></document>'! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/26/2017 22:47'!
addTreeViewChildrenTo: anOrderedCollection
	self hasDoctypeDeclaration
		ifTrue: [anOrderedCollection addLast: self doctypeDeclaration].
	super addTreeViewChildrenTo: anOrderedCollection.! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/17/2017 01:59'!
newSourceEditorTextStylerDecorator
	^ GLMXMLDocumentHighlighterTextStylerDecorator new
		configuration: self configuration! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/17/2017 02:09'!
setOuterXMLFromEditedSource: aString
	| newDocument |

	[newDocument :=
		(self parserHandlerClass on: aString)
			configuration: self configuration;
			parseDocument]
		on: Error
		do: [:error |
			newDocument := nil.
			error pass].
	newDocument
		ifNotNil: [
			self
				removeNodes;
				configuration: newDocument configuration;
				version: newDocument version;
				encoding: newDocument encoding;
				isStandalone: newDocument isStandalone;
				doctypeDeclaration: newDocument doctypeDeclaration;
				doctypeDefinition: newDocument doctypeDefinition;
				addNodes: newDocument nodes copy].
	^ self.! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/7/2017 09:29'!
supportsSourceEditing
	^ true! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/26/2017 21:54'!
supportsTreeView
	^ self hasDoctypeDeclaration
		or: [super supportsTreeView]! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/16/2016 13:02'!
writeTreeViewLabelXMLOn: aWriter
	self writeXMLDeclarationOn: aWriter! !

!XMLElement class methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/20/2015 22:19'!
gtExampleXmlNode
	<gtExample>
	^ XMLDocument gtExampleXmlNode firstElement! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'AndreiChis 7/12/2014 16:48'!
formForImageEntity: imageEntity
  | imageType parserClassName parserClass parser |
  imageType := imageEntity contentType sub.
  parserClassName := imageType asUppercase, #ReadWriter.
  parserClass := Smalltalk globals at: parserClassName asSymbol.
  parser := parserClass on: imageEntity readStream.
    ^ parser nextImage! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/2/2015 06:09'!
gtInspectorImageIn: composite inContext: aGTInspector
	<gtInspectorPresentationOrder: 40>
	| client url |
	aGTInspector panes size > 1
		ifFalse: [ ^ self ].
	client := (aGTInspector panes reversed collect: [ :each | (each port: #entity) value ])
		detect: [ :each | (each isKindOf: ZnClient) and: [ each request notNil ] ]
		ifNone: [ ^ self ].
	url := client request absoluteUrl.
	^ composite morph
		title: 'Image';
		display:
				[ self
				formForImageEntity:
					(ZnClient new
						beOneShot;
						get: url / (self attributeAt: 'src');
						entity) ];
		when: [ (self isNamed: 'img') and: [ self includesAttribute: 'src' ] ]! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/28/2017 05:30'!
supportsRemoveAction
	^ self hasParent
		and: [self parent isDocument not]! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/7/2017 09:29'!
supportsSourceEditing
	^ self hasParent! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/26/2017 23:05'!
writeTreeViewLabelXMLOn: aWriter
	self supportsTreeView
		ifTrue: [
			"write just an unclosed start tag if the element can be expanded
			to display tree view children"
			aWriter startTag
				name: self name;
				"uses setAttributes: for performance"
				setAttributes: attributes]
		ifFalse: [| tagWriter |
			(tagWriter := aWriter tag)
				name: self name;
				"uses setAttributes: for performance"
				setAttributes: attributes.
			"a non-expandable element can still have chilren (string nodes) that
			need to be written"
			self hasChildren
				ifTrue: [
					tagWriter with: [
						self writeInnerXMLOn: aWriter]]]! !

!XMLNode class methodsFor: '*XML-Parser-GTExtensions' stamp: 'AndreiChis 10/6/2015 10:47'!
gtExampleNodeWithParent
	<gtExample>
	^ self new parent: self new! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/1/2017 00:57'!
acceptEditedSource: aSourceTextOrString inContext: aGTInspector
	| newOuterXMLNode |

	newOuterXMLNode :=
		self setOuterXMLFromEditedSource: aSourceTextOrString asString.

	"find the previous panes of the first pane inspecting
	the receiver (not necessarily the current pane)"
	(aGTInspector panes
		copyFrom: 1
		to:
			(aGTInspector panes findFirst: [:each |
				(each port: #entity) value = self]) - 1)
		ifEmpty: [
			"no previous panes; delete any panes after the
			current and make its selection the new outer XML
			node (closing and reopening is a hack to do this,
			but it works for now)"
			aGTInspector browser close.
			aGTInspector openOn: newOuterXMLNode]
		ifNotEmpty: [:previousPanes |
			"update all previous panes and replace the first
			pane inspecting the receiver with one inspecting
			the new outer XML node"
			previousPanes do: [:each | each update].
			previousPanes last presentations first
				selection: newOuterXMLNode].! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/31/2017 00:56'!
addRemoveActionTo: aPresentation in: aComposite inContext: aGTInspector
	(self supportsRemoveAction not
		or: [aGTInspector panes size <= 1
			or: [(aGTInspector panes first port: #entity) value = self]])
		ifTrue: [^ self].

	aPresentation
		act: [| removeStartIndex |
			self removeFromParent.

			"remove all panes starting with the first pane inspecting
			the receiver (not necessarily the current pane)"
			removeStartIndex :=
				aGTInspector panes findFirst: [:each |
					(each port: #entity) value = self].
			removeStartIndex
				to: aGTInspector panes size
				do: [:i |
					aGTInspector removeLastPane].

			"update the remaining panes"
			aGTInspector panes do: [:each |
				each update]]
		icon: GLMUIThemeExtraIcons glamorousRemove
		on: $X
		entitled: 'Remove'.! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/28/2017 05:14'!
asHighlightedSourceText
	^ self asHighlightedTextWrittenWith: [:writer |
		"Add some formatting for the the non-content markup (markup outside
		the root element), because whatever formatting was there was
		lost during parsing. Avoid other formatting, to try to preserve the
		original."
		writer enablePrologPrettyPrinting.
		self writeXMLOn: writer]! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/7/2017 22:15'!
asHighlightedText
	^ self asHighlightedTextWrittenWith: [:writer |
		self writeXMLOn: writer]! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/28/2017 04:49'!
asHighlightedTextWrittenWith: aBlock
	| writer |

	writer := XMLHighlightingWriter new.
	self escapesContentEntitiesWhenWriting
		ifFalse: [writer escapesContentEntityReferences: false].
	aBlock value: writer.
	^ writer asHighlightedText.! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/15/2017 01:01'!
gtInspectorSourceIn: aComposite inContext: aGTInspector
	<gtInspectorPresentationOrder: 2>

	| sourceEditor currentTextStylerDecorator |

	sourceEditor :=
		aComposite custom: 
			(self supportsSourceEditing
				ifTrue: [
					GLMRubricHighlightedTextPresentation new
						editingMode: [
							currentTextStylerDecorator :=
								self newSourceEditorTextStylerDecorator.
							GLMHighlighterTextRubEditingMode withStylerDecorator:
								currentTextStylerDecorator];
						act: [
							self
								acceptEditedSource: currentTextStylerDecorator text
								inContext: aGTInspector]
							icon: GLMUIThemeExtraIcons glamorousAccept
							on: $s
							entitled: 'Accept';
						act: [
							self promptForSourceSaveFileName
								ifNotEmpty: [:fileName |
									self
										acceptEditedSource: currentTextStylerDecorator text
										inContext: aGTInspector.
									currentTextStylerDecorator saveToFile: fileName]]
							icon: GLMUIThemeExtraIcons glamorousSave
							entitled: 'Save as';
						act: [:presentation |
							presentation update]
							icon: GLMUIThemeExtraIcons glamorousUndo
							on: $Z
							entitled: 'Revert']
				ifFalse: [
					GLMXMLDisabledRubricHighlightedTextPresentation new
						editingMode: [
							currentTextStylerDecorator :=
								GLMXMLDisabledDocumentHighlighterTextStylerDecorator
									disabledText: self asHighlightedSourceText
									encoding:
										(self document
											ifNil: ['']
											ifNotNil: [:document | document encoding]).
							GLMHighlighterTextRubEditingMode withStylerDecorator:
								currentTextStylerDecorator];
						act: [
							self promptForSourceSaveFileName
								ifNotEmpty: [:fileName |
									currentTextStylerDecorator saveToFile: fileName]]
							icon: GLMUIThemeExtraIcons glamorousSave
							entitled: 'Save as']).

	sourceEditor
		title: 'Source';
		display: [self asHighlightedSourceText];
		withLineNumbers: true.

	self
		addRemoveActionTo: sourceEditor
		in: aComposite
		inContext: aGTInspector.! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/13/2017 02:33'!
gtInspectorTreeIn: aComposite inContext: aGTInspector
	<gtInspectorPresentationOrder: 1>

	| treeView |

	treeView :=
		aComposite tree
			title: 'Tree';
			display: [{self}];
			children: [:each | each treeViewChildren];
			format: [:each | each treeViewLabelText];
			when: [self supportsTreeView];
			rootsExpanded.

	self
		addRemoveActionTo: treeView
		in: aComposite
		inContext: aGTInspector! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/5/2017 16:14'!
newSourceEditorTextStylerDecorator
	^ GLMXMLOuterXMLDocumentHighlighterTextStylerDecorator outerXMLNode: self! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/30/2017 23:33'!
promptForSourceSaveFileName
	^ (UITheme builder
		fileSave: 'Save XML source to file'
		extensions:
			"'xml' must come first so it's the default extension"
			((XMLFileHandle xmlDocumentFileExtensions asArray copyWithout: 'xml')
				copyWithFirst: 'xml'))
			ifNil: ['']
			ifNotNil: [:reference | reference fullName]! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/27/2017 00:44'!
removeFromParent
	self parent removeNode: self! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/1/2017 00:50'!
setOuterXMLFromEditedSource: aString
	| oldParent oldPosition oldSize |

	oldParent := self parent.
	oldPosition := oldParent nodes indexOf: self.
	oldSize := oldParent nodes size.
	oldParent
		outerXML: aString
		forNode: self.
	^ oldParent nodes size = oldSize
		ifTrue: [oldParent nodes at: oldPosition]
		ifFalse: [oldParent].! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/28/2017 05:30'!
supportsRemoveAction
	^ self hasParent! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/7/2017 09:30'!
supportsSourceEditing
	^ self hasParent
		and: [self parent isDocument not]! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/26/2017 21:54'!
supportsTreeView
	"returns true if this node needs a tree view tab when inspected"
	^ false! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/16/2016 13:21'!
treeViewChildren
	"returns the subnodes of this node in a tree view"
	^ #()! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/3/2016 17:40'!
treeViewLabelText
	"the label Text of this node to be used in a tree view"
	^ self asHighlightedTextWrittenWith: [:writer |
		self writeTreeViewLabelXMLOn: writer]! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/16/2016 13:02'!
writeTreeViewLabelXMLOn: aWriter
	self writeXMLOn: aWriter! !

!XMLAttributeList methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/13/2015 13:19'!
gtInspectorItemsIn: aComposite
	^ self
		addOrderedListTableToComposite: aComposite
		paneTitle: 'Attributes'
		columnTitle: 'Attribute'! !

!XMLNodeList methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/13/2015 13:19'!
gtInspectorItemsIn: aComposite
	^ self
		addOrderedListTableToComposite: aComposite
		paneTitle: 'Nodes'
		columnTitle: 'Node'! !

SAXParserDriver subclass: #SAXPositionParserDriver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!SAXPositionParserDriver commentStamp: 'monty 3/6/2016 08:19' prior: 0!
This class is a SAX driver that forwards token start/end positions to a SAXHandler. Does not support entities or validation, but does support namespaces.!

!SAXPositionParserDriver methodsFor: 'testing' stamp: 'monty 9/30/2015 03:50'!
decodesCharacters
	^ false! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:44'!
handleEndCDataPosition: aPosition
	self saxHandler endCDataPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
handleEndCommentPosition: aPosition
	self saxHandler endCommentPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:45'!
handleEndDeclaration: aPosition
	self saxHandler endDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:33'!
handleEndDoctypeDeclarationPosition: aPosition
	self saxHandler endDoctypeDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:32'!
handleEndEntityReferencePosition: aPosition
	self saxHandler endEntityReferencePosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 4/5/2017 05:47'!
handleEndNamePosition: aPosition
	self saxHandler endNamePosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:31'!
handleEndPIPosition: aPosition
	self saxHandler endPIPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 4/5/2017 05:53'!
handleEndQuotedStringNamePosition: aPosition
	self saxHandler endQuotedStringNamePosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 4/1/2017 19:49'!
handleEndQuotedStringPosition: aPosition
	self saxHandler endQuotedStringPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:28'!
handleEndTagPosition: aPosition
	self saxHandler endTagPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:28'!
handleEndXMLDeclarationPosition: aPosition
	self saxHandler endXMLDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:43'!
handleStartCDataPosition: aPosition
	self saxHandler startCDataPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
handleStartCommentPosition: aPosition
	self saxHandler startCommentPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:45'!
handleStartDeclaration: aPosition
	self saxHandler startDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:33'!
handleStartDoctypeDeclarationPosition: aPosition
	self saxHandler startDoctypeDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:32'!
handleStartEntityReferencePosition: aPosition
	self saxHandler startEntityReferencePosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 4/5/2017 05:47'!
handleStartNamePosition: aPosition
	self saxHandler startNamePosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:31'!
handleStartPIPosition: aPosition
	self saxHandler startPIPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 4/5/2017 05:53'!
handleStartQuotedStringNamePosition: aPosition
	self saxHandler startQuotedStringNamePosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 4/1/2017 19:49'!
handleStartQuotedStringPosition: aPosition
	self saxHandler startQuotedStringPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:26'!
handleStartTagPosition: aPosition
	self saxHandler startTagPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:25'!
handleStartXMLDeclarationPosition: aPosition
	self saxHandler startXMLDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'testing' stamp: 'monty 9/30/2015 20:45'!
isValidating
	^ false! !

!SAXPositionParserDriver methodsFor: 'defaults' stamp: 'monty 10/1/2015 04:35'!
tokenizerClass
	^ XMLPositionWellFormedParserTokenizer! !

XMLPrettyPrintingWriterFormatter subclass: #XMLHighlightingPrettyPrintingWriterFormatter
	instanceVariableNames: 'highlighter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Writer'!

!XMLHighlightingPrettyPrintingWriterFormatter commentStamp: 'monty 3/7/2017 13:29' prior: 0!
This formatter adds highlights to pretty printed XMLHighlightingWriter output.

(Generated from XMLHighlightingWriterFormatter.)!

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'private' stamp: 'monty 4/5/2017 06:23'!
endPosition
	^ self writer position! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterCData: aCDataWriter
	highlighter endCDataHighlightPosition: self endPosition.

	super formatAfterCData: aCDataWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterCharacterEscape: aCharacterEscape
	highlighter endEntityReferenceHighlightPosition: self endPosition.

	super formatAfterCharacterEscape: aCharacterEscape.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterComment: aCommentWriter
	highlighter endCommentHighlightPosition: self endPosition.

	super formatAfterComment: aCommentWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterDeclaration: aDeclarationWriter
	highlighter endDeclarationHighlightPosition: self endPosition.

	super formatAfterDeclaration: aDeclarationWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter
	highlighter endDoctypeDeclarationHighlightPosition: self endPosition.

	super formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterEndTag: aTagWriter
	highlighter endTagHighlightPosition: self endPosition.

	super formatAfterEndTag: aTagWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterEntityReference: anEntityReferenceWriter
	highlighter endEntityReferenceHighlightPosition: self endPosition.

	super formatAfterEntityReference: anEntityReferenceWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterName: aName
	highlighter endNameHighlightPosition: self endPosition.

	super formatAfterName: aName.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterPI: aPIWriter
	highlighter endPIHighlightPosition: self endPosition.

	super formatAfterPI: aPIWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterQuotedStringName: aName
	highlighter endQuotedStringNameHighlightPosition: self endPosition.

	super formatAfterQuotedStringName: aName.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterQuotedStringValue: aString
	highlighter endQuotedStringHighlightPosition: self endPosition + 1.

	super formatAfterQuotedStringValue: aString.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterStartTag: aTagWriter
	highlighter endTagHighlightPosition: self endPosition.

	super formatAfterStartTag: aTagWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterXMLDeclaration: anXMLDeclarationWriter
	highlighter endXMLDeclarationHighlightPosition: self endPosition.

	super formatAfterXMLDeclaration: anXMLDeclarationWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeCData: aCDataWriter
	super formatBeforeCData: aCDataWriter.

	highlighter startCDataHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeCharacterEscape: aCharacterEscape
	super formatBeforeCharacterEscape: aCharacterEscape.

	highlighter startEntityReferenceHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeComment: aCommentWriter
	super formatBeforeComment: aCommentWriter.

	highlighter startCommentHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeDeclaration: aDeclarationWriter
	super formatBeforeDeclaration: aDeclarationWriter.

	highlighter startDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter
	super formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter.

	highlighter startDoctypeDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeEndTag: aTagWriter
	super formatBeforeEndTag: aTagWriter.

	highlighter startTagHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeEntityReference: anEntityReferenceWriter
	super formatBeforeEntityReference: anEntityReferenceWriter.

	highlighter startEntityReferenceHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeName: aName
	highlighter startNameHighlightPosition: self startPosition.

	super formatBeforeName: aName.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforePI: aPIWriter
	super formatBeforePI: aPIWriter.

	highlighter startPIHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeQuotedStringName: aName
	highlighter startQuotedStringNameHighlightPosition: self startPosition.

	super formatBeforeQuotedStringName: aName.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeQuotedStringValue: aString
	super formatBeforeQuotedStringValue: aString.

	highlighter startQuotedStringHighlightPosition: self startPosition - 1.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeStartTag: aTagWriter
	super formatBeforeStartTag: aTagWriter.

	highlighter startTagHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeXMLDeclaration: anXMLDeclarationWriter
	super formatBeforeXMLDeclaration: anXMLDeclarationWriter.

	highlighter startXMLDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'private' stamp: 'monty 4/5/2017 06:23'!
startPosition
	^ self writer position + 1! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:23'!
writer: aWriter
	super writer: aWriter.

	highlighter := aWriter highlighter.! !

Object subclass: #XMLExternalDocumentConverter
	instanceVariableNames: 'streamReader outputStream writeStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!XMLExternalDocumentConverter commentStamp: 'monty 2/14/2016 04:25' prior: 0!
This class converts an external XML document  into a string with line endings normalized to CRs (the Pharo/Squeak LE) and decodes it from any of the supported character encodings and will infer incodings from byte order marks or null bytes and also consider  <?xml ...?> encoding attributes.!

!XMLExternalDocumentConverter class methodsFor: 'converting' stamp: 'monty 10/2/2015 00:11'!
convert: aStringOrStream
	^ (self on: aStringOrStream) convert! !

!XMLExternalDocumentConverter class methodsFor: 'converting' stamp: 'monty 3/13/2016 13:21'!
convert: aStringOrStream readLimit: aReadLimit
	^ (self
		on: aStringOrStream
		readLimit: aReadLimit) convert! !

!XMLExternalDocumentConverter class methodsFor: 'converting' stamp: 'monty 2/14/2016 00:06'!
convertFileNamed: aFileName
	^ (self onFileNamed: aFileName) convert! !

!XMLExternalDocumentConverter class methodsFor: 'instance creation' stamp: 'monty 10/2/2015 00:11'!
on: aStringOrStream
	^ self
		on: aStringOrStream
		readLimit: XMLParserLimits defaultReadLimit! !

!XMLExternalDocumentConverter class methodsFor: 'instance creation' stamp: 'monty 9/29/2017 12:14'!
on: aStringOrStream readLimit: anInteger
	^ self new
		setStream:
			(aStringOrStream isStream
				ifTrue: [aStringOrStream]
				ifFalse: [aStringOrStream readStream])
		readLimit: anInteger! !

!XMLExternalDocumentConverter class methodsFor: 'instance creation' stamp: 'monty 1/21/2018 01:30'!
onFileNamed: aFileName
	^ self on:
		(XMLDecodingReadStreamAdapter nonDecodingOn:
			aFileName asXMLFileHandle rawReadStream)! !

!XMLExternalDocumentConverter methodsFor: 'closing' stamp: 'monty 10/2/2015 22:17'!
close
	streamReader closeStreams! !

!XMLExternalDocumentConverter methodsFor: 'accessing' stamp: 'monty 10/2/2015 22:18'!
contents
	^ outputStream contents! !

!XMLExternalDocumentConverter methodsFor: 'converting' stamp: 'monty 11/19/2016 19:12'!
convert
	^ self
		detectEncoding;
		nextXMLDeclaration;
		skipToEnd;
		close;
		contents! !

!XMLExternalDocumentConverter methodsFor: 'private ' stamp: 'monty 11/19/2016 19:12'!
detectEncoding
	streamReader detectEncoding
! !

!XMLExternalDocumentConverter methodsFor: 'private ' stamp: 'monty 9/19/2017 11:21'!
expectNextAll: aString
	aString do: [:each |
		"use #= for pre-SpurVM compatibility where wide chars aren't #=="
		self next = each
			ifFalse: [^ nil]].
	^ aString.! !

!XMLExternalDocumentConverter methodsFor: 'private ' stamp: 'monty 12/2/2015 20:08'!
next
	^ streamReader next
		ifNotNil: [:nextChar |
			outputStream nextPut: nextChar.
			nextChar]! !

!XMLExternalDocumentConverter methodsFor: 'private ' stamp: 'monty 10/2/2015 00:05'!
nextXMLAttributeNamed: anAttributeName
	| quote nextChar |

	self skipSeparators.
	(self expectNextAll: anAttributeName)
		ifNil: [^ nil].

	self skipSeparators.
	self next == $=
		ifFalse: [^ nil].
	self skipSeparators.

	((quote := self next) == $"
		or: [quote == $'])
		ifFalse: [^ nil].

	writeStream reset.
	[(nextChar := self next) isNil
		or: [nextChar == quote]]
		whileFalse: [writeStream nextPut: nextChar].

	nextChar
		ifNil: [^ nil]
		ifNotNil: [^ writeStream contents].! !

!XMLExternalDocumentConverter methodsFor: 'private ' stamp: 'monty 1/25/2018 01:49'!
nextXMLDeclaration
	self skipSeparators.
	(self expectNextAll: '<?xml')
		ifNil: [^ self].

	self skipSeparators.
	(self nextXMLAttributeNamed: 'version')
		ifNil: [^ self].

	self skipSeparators.
	(self nextXMLAttributeNamed: 'encoding')
		ifNotNil: [:encodingName |
			encodingName asXMLStreamConverter isNull
				ifFalse: [streamReader convertFromEncoding: encodingName]].! !

!XMLExternalDocumentConverter methodsFor: 'private ' stamp: 'monty 9/30/2015 19:21'!
peek
	^ streamReader peek! !

!XMLExternalDocumentConverter methodsFor: 'initialization' stamp: 'monty 1/21/2018 01:31'!
setStream: aStream readLimit: anInteger
	streamReader :=
		XMLNestedStreamReader
			on:
				(aStream isXMLConvertingStreamAdapter
					ifTrue: [aStream]
					ifFalse: [
						XMLDecodingReadStreamAdapter nonDecodingOnIfBinary:
							aStream])
			readLimit: anInteger.

	"this is the preferred LE char for Pharo/Squeak"
	streamReader normalizedLineEndingChar: Character cr.

	outputStream := (String new: 1024) writeStream.
	writeStream := (String new: 64) writeStream.! !

!XMLExternalDocumentConverter methodsFor: 'private ' stamp: 'monty 3/12/2016 19:09'!
skipSeparators
	[self peek isXMLSeparator]
		whileTrue: [self next]! !

!XMLExternalDocumentConverter methodsFor: 'private ' stamp: 'monty 10/2/2015 22:17'!
skipToEnd
	[self next notNil] whileTrue! !

Object subclass: #XMLHighlight
	instanceVariableNames: 'color start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting'!

!XMLHighlight commentStamp: 'monty 9/21/2015 04:24' prior: 0!
This class stores a highlight TextColor and 1-based start/end highlight positions.!

!XMLHighlight methodsFor: 'highlighting' stamp: 'monty 3/31/2017 02:39'!
applyToText: aText
	| attributeStart attributeEnd |

	"must be bounded between 1 and aText size to avoid errors if the text
	being highlighted was truncated by printString/asString"
	attributeStart := (self start ifNil: [1]) max: 1.
	attributeEnd := (self end ifNil: [aText size]) min: aText size.
	attributeStart <= attributeEnd
		ifTrue: [
			aText
				addAttribute: self color
				from: attributeStart
				to: attributeEnd].! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:08'!
color
	^ color! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:10'!
color: aTextColor
	color := aTextColor! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:08'!
end
	^ end! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:10'!
end: anEndPosition
	end := anEndPosition! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:08'!
start
	^ start! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:10'!
start: aStartPosition
	start := aStartPosition! !

Object subclass: #XMLHighlightDefaults
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting'!

XMLHighlightDefaults class
	instanceVariableNames: 'defaultDefaultColor uiTheme'!

!XMLHighlightDefaults commentStamp: 'monty 3/1/2017 18:34' prior: 0!
This is a base class for storing the default highlight TextColors used by a highlighter. It gets the initial defaults from Shout text styling.!

XMLHighlightDefaults class
	instanceVariableNames: 'defaultDefaultColor uiTheme'!

XMLHighlightDefaults subclass: #XMLDocumentHighlightDefaults
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting'!

XMLDocumentHighlightDefaults class
	instanceVariableNames: 'defaultXMLDeclarationColor defaultDoctypeDeclarationColor defaultPIColor defaultDeclarationColor defaultTagColor defaultNameColor defaultQuotedStringNameColor defaultQuotedStringColor defaultEntityReferenceColor defaultCommentColor defaultCDataColor'!

!XMLDocumentHighlightDefaults commentStamp: 'monty 3/1/2017 15:07' prior: 0!
This class stores the default highlight TextColors used by the document highlighter. It gets the initial defaults from Shout text styling.!

XMLDocumentHighlightDefaults class
	instanceVariableNames: 'defaultXMLDeclarationColor defaultDoctypeDeclarationColor defaultPIColor defaultDeclarationColor defaultTagColor defaultNameColor defaultQuotedStringNameColor defaultQuotedStringColor defaultEntityReferenceColor defaultCommentColor defaultCDataColor'!

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:29'!
defaultCDataColor
	^ defaultCDataColor
		ifNil: [defaultCDataColor := self textColorForShoutProperty: #primitive]! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:29'!
defaultCDataColor: aTextColor
	defaultCDataColor := aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:29'!
defaultCommentColor
	^ defaultCommentColor
		ifNil: [defaultCommentColor :=  self textColorForShoutProperty: #comment]! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:29'!
defaultCommentColor: aTextColor
	defaultCommentColor := aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:54'!
defaultDeclarationColor
	^ defaultDeclarationColor
		ifNil: [defaultDeclarationColor := self textColorForShoutProperty: #super]! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:36'!
defaultDeclarationColor: aTextColor
	defaultDeclarationColor := aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:54'!
defaultDoctypeDeclarationColor
	^ defaultDoctypeDeclarationColor
		ifNil: [
			defaultDoctypeDeclarationColor :=
				self textColorForShoutProperty: #super]! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:37'!
defaultDoctypeDeclarationColor: aTextColor
	defaultDoctypeDeclarationColor := aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:57'!
defaultEntityReferenceColor
	^ defaultEntityReferenceColor
		ifNil: [
			defaultEntityReferenceColor :=
				self textColorForShoutProperty: #character]! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:29'!
defaultEntityReferenceColor: aTextColor
	defaultEntityReferenceColor := aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:31'!
defaultNameColor
	^ defaultNameColor
		ifNil: [defaultNameColor := self textColorForShoutProperty: #instVar]! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:19'!
defaultNameColor: aTextColor
	defaultNameColor := aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:53'!
defaultPIColor
	^ defaultPIColor
		ifNil: [defaultPIColor := self textColorForShoutProperty: #primitive]! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:39'!
defaultPIColor: aTextColor
	defaultPIColor := aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:40'!
defaultPrimaryMarkupColor: aTextColor
	self
		defaultDeclarationColor: aTextColor;
		defaultTagColor: aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/1/2017 19:51'!
defaultQuotedStringColor
	^ defaultQuotedStringColor
		ifNil: [defaultQuotedStringColor := self textColorForShoutProperty: #string]! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/1/2017 19:51'!
defaultQuotedStringColor: aTextColor
	defaultQuotedStringColor := aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/5/2017 07:03'!
defaultQuotedStringNameColor
	^ defaultQuotedStringNameColor
		ifNil: [
			defaultQuotedStringNameColor :=
				self textColorForShoutProperty: #self]! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:17'!
defaultQuotedStringNameColor: aTextColor
	defaultQuotedStringNameColor := aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:38'!
defaultSecondaryMarkupColor: aTextColor
	self
		defaultXMLDeclarationColor: aTextColor;
		defaultDoctypeDeclarationColor: aTextColor;
		defaultPIColor: aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:46'!
defaultTagColor
	^ defaultTagColor
		ifNil: [defaultTagColor := self textColorForShoutProperty: #instVar]! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:40'!
defaultTagColor: aTextColor
	defaultTagColor := aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:53'!
defaultXMLDeclarationColor
	^ defaultXMLDeclarationColor
		ifNil: [defaultXMLDeclarationColor := self textColorForShoutProperty: #primitive]! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:35'!
defaultXMLDeclarationColor: aTextColor
	defaultXMLDeclarationColor := aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'class initialization' stamp: 'monty 4/16/2017 06:06'!
resetDefaults
	super resetDefaults.

	defaultXMLDeclarationColor := nil.
	defaultDoctypeDeclarationColor := nil.
	defaultPIColor := nil.
	defaultDeclarationColor := nil.
	defaultTagColor := nil.
	defaultNameColor := nil.
	defaultQuotedStringNameColor := nil.
	defaultQuotedStringColor := nil.
	defaultEntityReferenceColor := nil.
	defaultCommentColor := nil.
	defaultCDataColor := nil.! !

!XMLDocumentHighlightDefaults methodsFor: 'defaults' stamp: 'monty 4/16/2017 05:39'!
cdataColor
	^ self class defaultCDataColor! !

!XMLDocumentHighlightDefaults methodsFor: 'defaults' stamp: 'monty 4/16/2017 05:39'!
commentColor
	^ self class defaultCommentColor! !

!XMLDocumentHighlightDefaults methodsFor: 'defaults' stamp: 'monty 4/16/2017 05:39'!
declarationColor
	^ self class defaultDeclarationColor! !

!XMLDocumentHighlightDefaults methodsFor: 'defaults' stamp: 'monty 4/16/2017 05:39'!
doctypeDeclarationColor
	^ self class defaultDoctypeDeclarationColor! !

!XMLDocumentHighlightDefaults methodsFor: 'defaults' stamp: 'monty 4/16/2017 05:39'!
entityReferenceColor
	^ self class defaultEntityReferenceColor! !

!XMLDocumentHighlightDefaults methodsFor: 'defaults' stamp: 'monty 4/16/2017 05:39'!
nameColor
	^ self class defaultNameColor! !

!XMLDocumentHighlightDefaults methodsFor: 'defaults' stamp: 'monty 4/16/2017 05:39'!
piColor
	^ self class defaultPIColor! !

!XMLDocumentHighlightDefaults methodsFor: 'defaults' stamp: 'monty 4/16/2017 05:39'!
quotedStringColor
	^ self class defaultQuotedStringColor! !

!XMLDocumentHighlightDefaults methodsFor: 'defaults' stamp: 'monty 4/16/2017 05:39'!
quotedStringNameColor
	^ self class defaultQuotedStringNameColor! !

!XMLDocumentHighlightDefaults methodsFor: 'defaults' stamp: 'monty 4/16/2017 05:39'!
tagColor
	^ self class defaultTagColor! !

!XMLDocumentHighlightDefaults methodsFor: 'defaults' stamp: 'monty 4/16/2017 05:39'!
xmlDeclarationColor
	^ self class defaultXMLDeclarationColor! !

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultDefaultColor
	^ defaultDefaultColor
		ifNil: [defaultDefaultColor := self textColorForShoutProperty: #default]! !

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultDefaultColor: aTextColor
	defaultDefaultColor := aTextColor! !

!XMLHighlightDefaults class methodsFor: 'class initialization' stamp: 'monty 4/16/2017 06:07'!
initialize
	"self initialize"

	self resetDefaults! !

XMLHighlightDefaults initialize!

!XMLHighlightDefaults class methodsFor: 'instance creation' stamp: 'monty 4/16/2017 07:50'!
new
	"if the theme was changed since last initialization, reset the defaults"
	self uiTheme = Smalltalk ui theme
		ifFalse: [self resetDefaults].

	^ super new.! !

!XMLHighlightDefaults class methodsFor: 'class initialization' stamp: 'monty 4/16/2017 06:08'!
resetDefaults
	defaultDefaultColor := nil! !

!XMLHighlightDefaults class methodsFor: 'private' stamp: 'monty 9/30/2015 20:32'!
textColorForShoutProperty: aShoutProperty
	^ TextColor color:
		(((SHTextStylerST80 new attributesFor: aShoutProperty)
			detect: [:each | each respondsTo: #color]
			ifNone: [^ nil]) color)! !

!XMLHighlightDefaults class methodsFor: 'private' stamp: 'monty 4/16/2017 07:50'!
uiTheme
	^ uiTheme ifNil: [uiTheme := Smalltalk ui theme]! !

!XMLHighlightDefaults methodsFor: 'defaults' stamp: 'monty 4/16/2017 05:57'!
defaultColor
	^ self class defaultDefaultColor! !

Object subclass: #XMLHighlighter
	instanceVariableNames: 'highlights defaultHighlight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting'!

!XMLHighlighter commentStamp: 'monty 3/31/2017 02:02' prior: 0!
This is a base class for highlighters that highlight Text objects using XMLHighlights.!

XMLHighlighter subclass: #XMLDocumentHighlighter
	instanceVariableNames: 'xmlDeclarationColor doctypeDeclarationColor declarationColor piColor tagColor nameColor quotedStringNameColor quotedStringColor entityReferenceColor cdataColor commentColor xmlDeclarationHighlight doctypeDeclarationHighlight declarationHighlight piHighlight tagHighlight nameHighlight quotedStringNameHighlight quotedStringHighlight entityReferenceHighlight cdataHighlight commentHighlight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting'!

!XMLDocumentHighlighter commentStamp: 'monty 3/31/2017 02:02' prior: 0!
This class is a highlighter to highlight XML document Text objects using XMLHighlights.!

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
cdataColor
	^ cdataColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
cdataColor: aTextColor
	cdataColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
commentColor
	^ commentColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
commentColor: aTextColor
	commentColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
declarationColor
	^ declarationColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
declarationColor: aTextColor
	declarationColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'defaults' stamp: 'monty 4/16/2017 05:46'!
defaultsClass
	^ XMLDocumentHighlightDefaults! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
doctypeDeclarationColor
	^ doctypeDeclarationColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
doctypeDeclarationColor: aTextColor
	doctypeDeclarationColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
endCDataHighlightPosition: aPosition
	self
		endHighlight: cdataHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
endCommentHighlightPosition: aPosition
	self
		endHighlight: commentHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
endDeclarationHighlightPosition: aPosition
	self
		endHighlight: declarationHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
endDoctypeDeclarationHighlightPosition: aPosition
	self
		endHighlight: doctypeDeclarationHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
endEntityReferenceHighlightPosition: aPosition
	self
		endHighlight: entityReferenceHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 4/3/2017 23:15'!
endNameHighlightPosition: aPosition
	self
		endHighlight: nameHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
endPIHighlightPosition: aPosition
	self
		endHighlight: piHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 4/1/2017 19:53'!
endQuotedStringHighlightPosition: aPosition
	self
		endHighlight: quotedStringHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 4/5/2017 06:10'!
endQuotedStringNameHighlightPosition: aPosition
	self
		endHighlight: quotedStringNameHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
endTagHighlightPosition: aPosition
	self
		endHighlight: tagHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
endXMLDeclarationHighlightPosition: aPosition
	self
		endHighlight: xmlDeclarationHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
entityReferenceColor
	^ entityReferenceColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
entityReferenceColor: aTextColor
	entityReferenceColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'initialization' stamp: 'monty 4/16/2017 07:50'!
initializeColorsWithDefaults: aDefaults
	super initializeColorsWithDefaults: aDefaults.

	self
		xmlDeclarationColor: aDefaults xmlDeclarationColor;
		doctypeDeclarationColor: aDefaults doctypeDeclarationColor;
		piColor: aDefaults piColor;
		declarationColor: aDefaults declarationColor;
		tagColor: aDefaults tagColor;
		nameColor: aDefaults nameColor;
		quotedStringNameColor: aDefaults quotedStringNameColor;
		quotedStringColor: aDefaults quotedStringColor;
		entityReferenceColor: aDefaults entityReferenceColor;
		commentColor: aDefaults commentColor;
		cdataColor: aDefaults cdataColor.! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:11'!
nameColor
	^ nameColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:11'!
nameColor: aTextColor
	nameColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
piColor
	^ piColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
piColor: aTextColor
	piColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 4/1/2017 19:55'!
quotedStringColor
	^ quotedStringColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 4/1/2017 19:55'!
quotedStringColor: aTextColor
	quotedStringColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:11'!
quotedStringNameColor
	^ quotedStringNameColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:11'!
quotedStringNameColor: aTextColor
	quotedStringNameColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
startCDataHighlightPosition: aPosition
	cdataHighlight :=
		self
			newHighlightColor: self cdataColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
startCommentHighlightPosition: aPosition
	commentHighlight :=
		self
			newHighlightColor: self commentColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
startDeclarationHighlightPosition: aPosition
	declarationHighlight :=
		self
			newHighlightColor: self declarationColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
startDoctypeDeclarationHighlightPosition: aPosition
	doctypeDeclarationHighlight :=
		self
			newHighlightColor: self doctypeDeclarationColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
startEntityReferenceHighlightPosition: aPosition
	entityReferenceHighlight :=
		self
			newHighlightColor: self entityReferenceColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 4/3/2017 23:24'!
startNameHighlightPosition: aPosition
	nameHighlight :=
		self
			newHighlightColor: self nameColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
startPIHighlightPosition: aPosition
	piHighlight :=
		self
			newHighlightColor: self piColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 4/1/2017 19:55'!
startQuotedStringHighlightPosition: aPosition
	quotedStringHighlight :=
		self
			newHighlightColor: self quotedStringColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 4/5/2017 06:11'!
startQuotedStringNameHighlightPosition: aPosition
	quotedStringNameHighlight :=
		self
			newHighlightColor: self quotedStringNameColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
startTagHighlightPosition: aPosition
	tagHighlight :=
		self
			newHighlightColor: self tagColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
startXMLDeclarationHighlightPosition: aPosition
	xmlDeclarationHighlight :=
		self
			newHighlightColor: self xmlDeclarationColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
tagColor
	^ tagColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
tagColor: aTextColor
	tagColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
xmlDeclarationColor
	^ xmlDeclarationColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
xmlDeclarationColor: aTextColor
	xmlDeclarationColor := aTextColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:22'!
defaultColor
	^ defaultHighlight color! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:22'!
defaultColor: aTextColor
	defaultHighlight color: aTextColor! !

!XMLHighlighter methodsFor: 'defaults' stamp: 'monty 4/16/2017 05:45'!
defaults
	^ self defaultsClass new! !

!XMLHighlighter methodsFor: 'defaults' stamp: 'monty 4/16/2017 05:46'!
defaultsClass
	^ XMLHighlightDefaults! !

!XMLHighlighter methodsFor: 'private' stamp: 'monty 10/1/2015 03:29'!
endHighlight: aHighlightOrNil position: aPosition
	aHighlightOrNil
		ifNotNil: [aHighlightOrNil end: aPosition]! !

!XMLHighlighter methodsFor: 'highlighting' stamp: 'monty 10/1/2015 04:06'!
highlightText: aText
	highlights do: [:each | each applyToText: aText]! !

!XMLHighlighter methodsFor: 'highlighting' stamp: 'monty 10/2/2015 02:11'!
highlightText: aText withColor: aTextColor startingAt: aPosition
	XMLHighlight new
		color: aTextColor;
		start: aPosition;
		applyToText: aText! !

!XMLHighlighter methodsFor: 'initialization' stamp: 'monty 4/16/2017 05:49'!
initialize
	super initialize.

	self
		initializeHighlights;
		initializeColorsWithDefaults: self defaults.! !

!XMLHighlighter methodsFor: 'initialization' stamp: 'monty 4/16/2017 05:48'!
initializeColorsWithDefaults: aDefaults
	self defaultColor: aDefaults defaultColor! !

!XMLHighlighter methodsFor: 'initialization' stamp: 'monty 2/27/2017 17:25'!
initializeHighlights
	defaultHighlight := XMLHighlight new.
	highlights := OrderedCollection with: defaultHighlight.! !

!XMLHighlighter methodsFor: 'private' stamp: 'monty 10/1/2015 03:41'!
newHighlightColor: aTextColor position: aPosition
	^ aTextColor
		ifNotNil: [
			highlights addLast:
				(XMLHighlight new
					color: aTextColor;
					start: aPosition)]! !

!XMLLazyAttributeDictionary methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 8/31/2017 05:51'!
gtInspectorItemsIn: aComposite
	attributeDictionary gtInspectorItemsIn: aComposite! !

XMLCanonicalWriterFormatter subclass: #XMLHighlightingCanonicalWriterFormatter
	instanceVariableNames: 'highlighter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Writer'!

!XMLHighlightingCanonicalWriterFormatter commentStamp: 'monty 3/7/2017 13:29' prior: 0!
This formatter adds highlights to canonical XMLHighlightingWriter output.

(Generated from XMLHighlightingWriterFormatter.)!

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'private' stamp: 'monty 4/5/2017 06:23'!
endPosition
	^ self writer position! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterCData: aCDataWriter
	highlighter endCDataHighlightPosition: self endPosition.

	super formatAfterCData: aCDataWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterCharacterEscape: aCharacterEscape
	highlighter endEntityReferenceHighlightPosition: self endPosition.

	super formatAfterCharacterEscape: aCharacterEscape.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterComment: aCommentWriter
	highlighter endCommentHighlightPosition: self endPosition.

	super formatAfterComment: aCommentWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterDeclaration: aDeclarationWriter
	highlighter endDeclarationHighlightPosition: self endPosition.

	super formatAfterDeclaration: aDeclarationWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter
	highlighter endDoctypeDeclarationHighlightPosition: self endPosition.

	super formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterEndTag: aTagWriter
	highlighter endTagHighlightPosition: self endPosition.

	super formatAfterEndTag: aTagWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterEntityReference: anEntityReferenceWriter
	highlighter endEntityReferenceHighlightPosition: self endPosition.

	super formatAfterEntityReference: anEntityReferenceWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterName: aName
	highlighter endNameHighlightPosition: self endPosition.

	super formatAfterName: aName.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterPI: aPIWriter
	highlighter endPIHighlightPosition: self endPosition.

	super formatAfterPI: aPIWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterQuotedStringName: aName
	highlighter endQuotedStringNameHighlightPosition: self endPosition.

	super formatAfterQuotedStringName: aName.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterQuotedStringValue: aString
	highlighter endQuotedStringHighlightPosition: self endPosition + 1.

	super formatAfterQuotedStringValue: aString.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterStartTag: aTagWriter
	highlighter endTagHighlightPosition: self endPosition.

	super formatAfterStartTag: aTagWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterXMLDeclaration: anXMLDeclarationWriter
	highlighter endXMLDeclarationHighlightPosition: self endPosition.

	super formatAfterXMLDeclaration: anXMLDeclarationWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeCData: aCDataWriter
	super formatBeforeCData: aCDataWriter.

	highlighter startCDataHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeCharacterEscape: aCharacterEscape
	super formatBeforeCharacterEscape: aCharacterEscape.

	highlighter startEntityReferenceHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeComment: aCommentWriter
	super formatBeforeComment: aCommentWriter.

	highlighter startCommentHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeDeclaration: aDeclarationWriter
	super formatBeforeDeclaration: aDeclarationWriter.

	highlighter startDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter
	super formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter.

	highlighter startDoctypeDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeEndTag: aTagWriter
	super formatBeforeEndTag: aTagWriter.

	highlighter startTagHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeEntityReference: anEntityReferenceWriter
	super formatBeforeEntityReference: anEntityReferenceWriter.

	highlighter startEntityReferenceHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeName: aName
	highlighter startNameHighlightPosition: self startPosition.

	super formatBeforeName: aName.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforePI: aPIWriter
	super formatBeforePI: aPIWriter.

	highlighter startPIHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeQuotedStringName: aName
	highlighter startQuotedStringNameHighlightPosition: self startPosition.

	super formatBeforeQuotedStringName: aName.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeQuotedStringValue: aString
	super formatBeforeQuotedStringValue: aString.

	highlighter startQuotedStringHighlightPosition: self startPosition - 1.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeStartTag: aTagWriter
	super formatBeforeStartTag: aTagWriter.

	highlighter startTagHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeXMLDeclaration: anXMLDeclarationWriter
	super formatBeforeXMLDeclaration: anXMLDeclarationWriter.

	highlighter startXMLDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'private' stamp: 'monty 4/5/2017 06:23'!
startPosition
	^ self writer position + 1! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:23'!
writer: aWriter
	super writer: aWriter.

	highlighter := aWriter highlighter.! !

XMLWriterFormatter subclass: #XMLHighlightingWriterFormatter
	instanceVariableNames: 'highlighter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Writer'!

!XMLHighlightingWriterFormatter commentStamp: 'monty 3/7/2017 13:29' prior: 0!
This formatter adds highlights to XMLHighlightingWriter output.!

!XMLHighlightingWriterFormatter class methodsFor: 'private' stamp: 'monty 4/3/2017 23:20'!
generateHighlightingSubclassOf: aFormatterClass named: aName inCategory: aCategory
	"
	self
		generateHighlightingSubclassOf: XMLPrologPrettyPrintingWriterFormatter
		named: #XMLHighlightingPrologPrettyPrintingWriterFormatter
		inCategory: self category.
	self
		generateHighlightingSubclassOf: XMLPrettyPrintingWriterFormatter
		named: #XMLHighlightingPrettyPrintingWriterFormatter
		inCategory: self category.
	self
		generateHighlightingSubclassOf: XMLCanonicalWriterFormatter
		named: #XMLHighlightingCanonicalWriterFormatter
		inCategory: self category.
	"
	| newSubclass |

	(aFormatterClass == self
		or: [aFormatterClass class inheritsFrom: self])
		ifTrue: [
			^ aFormatterClass
				subclass: aName asSymbol
				instanceVariableNames: ''
				classVariableNames: ''
				category: aCategory asSymbol].

	newSubclass :=
		aFormatterClass
			subclass: aName asSymbol
			instanceVariableNames: 'highlighter'
			classVariableNames: ''
			category: aCategory asSymbol.
	self selectors do: [:each |
		newSubclass
			compile: (self sourceCodeAt: each)
			classified: (self whichCategoryIncludesSelector: each)].

	^ newSubclass.! !

!XMLHighlightingWriterFormatter methodsFor: 'private' stamp: 'monty 3/28/2017 04:19'!
endPosition
	^ self writer position! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterCData: aCDataWriter
	highlighter endCDataHighlightPosition: self endPosition.

	super formatAfterCData: aCDataWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterCharacterEscape: aCharacterEscape
	highlighter endEntityReferenceHighlightPosition: self endPosition.

	super formatAfterCharacterEscape: aCharacterEscape.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterComment: aCommentWriter
	highlighter endCommentHighlightPosition: self endPosition.

	super formatAfterComment: aCommentWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterDeclaration: aDeclarationWriter
	highlighter endDeclarationHighlightPosition: self endPosition.

	super formatAfterDeclaration: aDeclarationWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter
	highlighter endDoctypeDeclarationHighlightPosition: self endPosition.

	super formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterEndTag: aTagWriter
	highlighter endTagHighlightPosition: self endPosition.

	super formatAfterEndTag: aTagWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterEntityReference: anEntityReferenceWriter
	highlighter endEntityReferenceHighlightPosition: self endPosition.

	super formatAfterEntityReference: anEntityReferenceWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/3/2017 23:14'!
formatAfterName: aName
	highlighter endNameHighlightPosition: self endPosition.

	super formatAfterName: aName.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterPI: aPIWriter
	highlighter endPIHighlightPosition: self endPosition.

	super formatAfterPI: aPIWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterQuotedStringName: aName
	highlighter endQuotedStringNameHighlightPosition: self endPosition.

	super formatAfterQuotedStringName: aName.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/1/2017 19:50'!
formatAfterQuotedStringValue: aString
	highlighter endQuotedStringHighlightPosition: self endPosition + 1.

	super formatAfterQuotedStringValue: aString.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterStartTag: aTagWriter
	highlighter endTagHighlightPosition: self endPosition.

	super formatAfterStartTag: aTagWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterXMLDeclaration: anXMLDeclarationWriter
	highlighter endXMLDeclarationHighlightPosition: self endPosition.

	super formatAfterXMLDeclaration: anXMLDeclarationWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeCData: aCDataWriter
	super formatBeforeCData: aCDataWriter.

	highlighter startCDataHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeCharacterEscape: aCharacterEscape
	super formatBeforeCharacterEscape: aCharacterEscape.

	highlighter startEntityReferenceHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeComment: aCommentWriter
	super formatBeforeComment: aCommentWriter.

	highlighter startCommentHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeDeclaration: aDeclarationWriter
	super formatBeforeDeclaration: aDeclarationWriter.

	highlighter startDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter
	super formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter.

	highlighter startDoctypeDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeEndTag: aTagWriter
	super formatBeforeEndTag: aTagWriter.

	highlighter startTagHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeEntityReference: anEntityReferenceWriter
	super formatBeforeEntityReference: anEntityReferenceWriter.

	highlighter startEntityReferenceHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/3/2017 23:21'!
formatBeforeName: aName
	highlighter startNameHighlightPosition: self startPosition.

	super formatBeforeName: aName.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforePI: aPIWriter
	super formatBeforePI: aPIWriter.

	highlighter startPIHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeQuotedStringName: aName
	highlighter startQuotedStringNameHighlightPosition: self startPosition.

	super formatBeforeQuotedStringName: aName.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/1/2017 19:50'!
formatBeforeQuotedStringValue: aString
	super formatBeforeQuotedStringValue: aString.

	highlighter startQuotedStringHighlightPosition: self startPosition - 1.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeStartTag: aTagWriter
	super formatBeforeStartTag: aTagWriter.

	highlighter startTagHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeXMLDeclaration: anXMLDeclarationWriter
	super formatBeforeXMLDeclaration: anXMLDeclarationWriter.

	highlighter startXMLDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'private' stamp: 'monty 3/7/2017 13:03'!
startPosition
	^ self writer position + 1! !

!XMLHighlightingWriterFormatter methodsFor: 'accessing' stamp: 'monty 3/7/2017 13:02'!
writer: aWriter
	super writer: aWriter.

	highlighter := aWriter highlighter.! !

!XMLDeclarationNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/7/2017 09:29'!
supportsSourceEditing
	^ false! !

!XMLAttribute methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/27/2017 00:45'!
removeFromParent
	self parent removeAttributeNode: self! !

!XMLAttribute methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/7/2017 09:29'!
supportsSourceEditing
	^ false! !

!FileReference methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 1/17/2018 16:07'!
gtInspectorXMLFileIn: aComposite
	<gtInspectorPresentationOrder: 4>

	| xmlFileHandle currentTextStylerDecorator |

	xmlFileHandle := XMLFileSystemFileHandle fileReference: self.
	xmlFileHandle isXMLDocumentFile
		ifFalse: [^ self].

	aComposite custom:
		(GLMRubricHighlightedTextPresentation new
			title: 'Source';
			editingMode: [
				"saved to get the encoding later"
				currentTextStylerDecorator :=
					GLMXMLDocumentHighlighterTextStylerDecorator new.
				GLMHighlighterTextRubEditingMode withStylerDecorator:
					currentTextStylerDecorator];
			display: [
				XMLExternalDocumentConverter convertFileNamed:
					xmlFileHandle path];
			withLineNumbers: true;
			act: [:presentation |
				currentTextStylerDecorator saveToFile: xmlFileHandle.
				"update the entire pane, not just this presentation,
				because the file contents have changed"
				presentation pane update]
				icon: GLMUIThemeExtraIcons glamorousSave
				on: $s
				entitled: 'Save';
			act: [:presentation |
				"revert edits only in this presentation"
				presentation update]
				icon: GLMUIThemeExtraIcons glamorousUndo
				on: $Z
				entitled: 'Revert';
			"the selection action was removed because it reports the
			wrong #selectionText if the previous presentation viewed
			was a text presentation with a selection"
			act: [:presentation |
				"do not clear user edits because the source hasn't
				been accepted/saved"
				presentation selection:
					(XMLDOMParser parse:
						currentTextStylerDecorator text asString)]
				icon: GLMUIThemeExtraIcons glamorousGo
				on: $g
				entitled: 'Parse and go').! !

!FileReference methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/16/2017 08:11'!
spotterForXMLFileFor: aStep
	<spotterOrder: 40>

	| xmlFileHandle |

	xmlFileHandle := XMLFileSystemFileHandle fileReference: self.
	xmlFileHandle isXMLDocumentFile
		ifFalse: [^ self].

	aStep listProcessor
		title: 'XML Document';
		allCandidates: [
			(XMLDOMParser parseFileNamed: xmlFileHandle path)
				allElements];
		itemName: #gtDisplayString;
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true.! !

!FileReference methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 1/17/2018 16:07'!
spotterPreviewXMLFileIn: aComposite
	<spotterPreview: 10>

	| xmlFileHandle |

	xmlFileHandle := XMLFileSystemFileHandle fileReference: self.
	xmlFileHandle isXMLDocumentFile
		ifFalse: [^ self].

	aComposite text
		title: 'Source';
		display: [
			"the source is converted to a decoded string and then highlighted"
			XMLHighlightingParser parse:
				(XMLExternalDocumentConverter convertFileNamed:
					xmlFileHandle path)];
		entity: self.! !

GLMRubricHighlightedTextPresentation subclass: #GLMXMLDisabledRubricHighlightedTextPresentation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!GLMXMLDisabledRubricHighlightedTextPresentation commentStamp: 'monty 3/5/2017 13:03' prior: 0!
A disabled version of the superclass.!

!GLMXMLDisabledRubricHighlightedTextPresentation methodsFor: 'rendering' stamp: 'monty 3/5/2017 12:33'!
renderGlamorouslyOn: aRenderer
	^ (super renderGlamorouslyOn: aRenderer)
		beReadOnly;
		yourself! !

!XMLNodeWithElements class methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/20/2015 22:19'!
gtExampleXmlNode
	<gtExample>
	^ XMLDocument gtExampleXmlNode nodes! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/26/2017 22:46'!
addTreeViewChildrenTo: anOrderedCollection
	self nodesDo: [:each |
		(each isStringNode
			and: [each isEmpty
				or: [each isWhitespace]])
			ifFalse: [anOrderedCollection addLast: each]]! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/1/2015 06:03'!
spotterForAllElementsFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
		title: 'All elements';
		allCandidates: [self allElements];
		itemName: #gtDisplayString;
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/1/2015 06:03'!
spotterForDirectElementsFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
		title: 'Direct elements';
		allCandidates: [self elements];
		itemName: #gtDisplayString;
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 23:16'!
spotterPreviewSourceIn: aComposite
	<spotterPreview: 10>
	
	aComposite text
		title: 'Source';
		display: [
			self asHighlightedTextWrittenWith: [:writer |
				"use less indent for spotter previews"
				writer formatter indentString: '  '.
				self writeXMLOn: writer]];
		entity: self! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/26/2017 22:42'!
supportsTreeView
	^ self hasChildren
		and: [self nodes anySatisfy: [:each | each isStringNode not]]! !

XMLWriter subclass: #XMLHighlightingWriter
	instanceVariableNames: 'highlighter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Writer'!

!XMLHighlightingWriter commentStamp: 'monty 10/1/2015 04:20' prior: 0!
This class is an XMLWriter that can make highlighted text output with XMLHighlightingPrettyPrintingWriterFormatter and XMLHighlighter.!

!XMLHighlightingWriter methodsFor: 'converting' stamp: 'monty 3/6/2016 09:05'!
asHighlightedText
	| text |

	"printString/asString forward to printStringLimitedTo: which truncates,
	so contents is used instead to get the complete text"
	text := self contents asText.
	self highlighter highlightText: text.
	^ text.! !

!XMLHighlightingWriter methodsFor: 'defaults' stamp: 'monty 3/7/2017 13:25'!
canonicalWriterFormatterClass
	^ XMLHighlightingCanonicalWriterFormatter! !

!XMLHighlightingWriter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:19'!
highlighter
	^ highlighter! !

!XMLHighlightingWriter methodsFor: 'initialization' stamp: 'monty 7/28/2017 11:23'!
on: aStream
	super on: aStream.

	highlighter := XMLDocumentHighlighter new.
	self formatter: XMLHighlightingWriterFormatter new.! !

!XMLHighlightingWriter methodsFor: 'defaults' stamp: 'monty 3/7/2017 13:24'!
prettyPrintingWriterFormatterClass
	^ XMLHighlightingPrettyPrintingWriterFormatter! !

!XMLHighlightingWriter methodsFor: 'defaults' stamp: 'monty 3/28/2017 05:00'!
prologPrettyPrintingWriterFormatterClass
	^ XMLHighlightingPrologPrettyPrintingWriterFormatter! !

XMLWellFormedParserTokenizer subclass: #XMLPositionWellFormedParserTokenizer
	instanceVariableNames: 'isInEntityReference isInAttlistDeclaration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!XMLPositionWellFormedParserTokenizer commentStamp: 'monty 3/6/2016 08:18' prior: 0!
This class is a tokenizer for well-formed XML that tracks token start/end positions. Does not support entities or validation.!

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/12/2017 00:53'!
nextAttlistDeclaration
	isInAttlistDeclaration := true.
	super nextAttlistDeclaration.
	isInAttlistDeclaration := false.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/12/2017 00:53'!
nextAttributeName
	| name |

	isInAttlistDeclaration
		ifTrue: [
			driver handleStartNamePosition: self currentPosition + 1.
			name := super nextAttributeName.
			driver handleEndNamePosition: self currentPosition]
		ifFalse: [
			driver handleStartQuotedStringNamePosition: self currentPosition + 1.
			name := super nextAttributeName.
			driver handleEndQuotedStringNamePosition: self currentPosition].

	^ name.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/13/2017 04:57'!
nextAttributeValue
	| value |

	driver handleStartQuotedStringPosition: self currentPosition + 1.
	value := super nextAttributeValue.
	driver handleEndQuotedStringPosition: self currentPosition.

	^ value.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 3/19/2016 00:36'!
nextCDataSection
	driver handleStartCDataPosition: self currentPosition - 1.
	super nextCDataSection.
	driver handleEndCDataPosition: self currentPosition.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/13/2017 04:11'!
nextCharacterReferenceOnCharacterStream
	| result |

	driver handleStartEntityReferencePosition: self currentPosition.
	result := super nextCharacterReferenceOnCharacterStream.
	driver handleEndEntityReferencePosition: self currentPosition.

	^ result.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 3/19/2016 00:36'!
nextComment
	driver handleStartCommentPosition: self currentPosition - 1.
	super nextComment.
	driver handleEndCommentPosition: self currentPosition.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 3/19/2016 00:37'!
nextDoctypeDeclaration
	driver handleStartDoctypeDeclarationPosition: self currentPosition - 1.
	super nextDoctypeDeclaration.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/5/2017 05:46'!
nextElementName
	| name |

	driver handleStartNamePosition: self currentPosition + 1.
	name := super nextElementName.
	driver handleEndNamePosition: self currentPosition.

	^ name.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/13/2017 04:13'!
nextElementNameOnCharacterStream
	driver handleStartNamePosition: self currentPosition + 1.
	super nextElementNameOnCharacterStream.
	driver handleEndNamePosition: self currentPosition.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 3/19/2016 00:37'!
nextEndDoctypeDeclaration
	super nextEndDoctypeDeclaration.
	driver handleEndDoctypeDeclarationPosition: self currentPosition.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/5/2017 06:26'!
nextEndTag
	| startPosition |

	startPosition := self currentPosition + 2.
	super nextEndTag.
	driver
		handleStartNamePosition: startPosition;
		handleEndNamePosition: self currentPosition - 1.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/12/2017 01:01'!
nextEntityName
	isInEntityReference
		ifTrue: [^ super nextEntityName]
		ifFalse: [| entityName |
			driver handleStartNamePosition: self currentPosition + 1.
			entityName := super nextEntityName.
			driver handleEndNamePosition: self currentPosition.
			^ entityName]! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/13/2017 04:57'!
nextEntityValue
	| value |

	driver handleStartQuotedStringPosition: self currentPosition + 1.
	value := super nextEntityValue.
	driver handleEndQuotedStringPosition: self currentPosition.

	^ value.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/13/2017 04:12'!
nextGeneralEntityReferenceOnCharacterStream
	isInEntityReference := true.
	driver handleStartEntityReferencePosition: self currentPosition.
	self nextEntityName.
	driver handleEndEntityReferencePosition: self currentPosition + 1.
	self expectNext: $;.
	isInEntityReference := false.

	^ nil.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/13/2017 04:14'!
nextNmtokenOnCharacterStream
	driver handleStartNamePosition: self currentPosition + 1.
	super nextNmtokenOnCharacterStream.
	driver handleEndNamePosition: self currentPosition.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/5/2017 05:48'!
nextNotationName
	| name |

	driver handleStartNamePosition: self currentPosition + 1.
	name := super nextNotationName.
	driver handleEndNamePosition: self currentPosition.

	^ name.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/13/2017 04:14'!
nextNotationNameOnCharacterStream
	driver handleStartNamePosition: self currentPosition + 1.
	super nextNotationNameOnCharacterStream.
	driver handleEndNamePosition: self currentPosition.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/13/2017 04:10'!
nextPIData
	| nextChar quotedStringNameStart quotedStringStart quote |

	characterStream reset.
	[(nextChar := streamReader next) == nil
		or: [nextChar == $?
			and: [streamReader peek == $>]]]
		whileFalse: [
			nextChar isXMLChar
				ifFalse: [self errorNonCharInPIValue: nextChar].
			quotedStringStart
				ifNil: [
					quotedStringNameStart
						ifNil: [
							nextChar isXMLNameStartChar
								ifTrue: [quotedStringNameStart := self currentPosition]
								ifFalse: [
									(nextChar == $"
										or: [nextChar == $'])
										ifTrue: [
											quote := nextChar.
											quotedStringStart := self currentPosition]]]
						ifNotNil: [
							nextChar isXMLNameChar
								ifFalse: [
									driver
										handleStartQuotedStringNamePosition:
											quotedStringNameStart;
										handleEndQuotedStringNamePosition:
											self currentPosition - 1.
									quotedStringNameStart := nil.
									(nextChar == $"
										or: [nextChar == $'])
										ifTrue: [
											quote := nextChar.
											quotedStringStart := self currentPosition]]]]
				ifNotNil: [
					nextChar == quote
						ifTrue: [
							driver
								handleStartQuotedStringPosition: quotedStringStart;
								handleEndQuotedStringPosition: self currentPosition.
							quotedStringStart := nil]]].
	"ignore unterminated strings, but handle terminating names"
	quotedStringNameStart
		ifNotNil: [
			driver
				handleStartQuotedStringNamePosition: quotedStringNameStart;
				handleEndQuotedStringNamePosition: self currentPosition - 1].

	self expectTerminator.
	^ characterStream contents.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 3/19/2016 00:37'!
nextPIWithTarget: aTarget
	driver handleStartPIPosition: self currentPosition - (aTarget size + 1).
	super nextPIWithTarget: aTarget.
	driver handleEndPIPosition: self currentPosition.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/12/2017 00:56'!
nextParameterEntityReference
	isInEntityReference := true.
	driver handleStartEntityReferencePosition: self currentPosition.
	self nextEntityName.
	driver handleEndEntityReferencePosition: self currentPosition + 1.
	self expectNext: $;.
	isInEntityReference := false.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/1/2015 05:11'!
nextParameterEntityReferenceInDeclaration
	^ self nextParameterEntityReference! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/13/2017 04:14'!
nextParameterEntityReferenceOnCharacterStream
	^ self nextParameterEntityReference! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/1/2017 19:49'!
nextPublicIDLiteral
	| publicID |

	driver handleStartQuotedStringPosition: self currentPosition + 1.
	publicID := super nextPublicIDLiteral.
	driver handleEndQuotedStringPosition: self currentPosition.

	^ publicID.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 3/19/2016 00:47'!
nextSubsetDeclaration
	driver handleStartDeclaration: self currentPosition - 1.
	super nextSubsetDeclaration.
	driver handleEndDeclaration: self currentPosition.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/1/2017 19:49'!
nextSystemIDLiteral
	| systemID |

	driver handleStartQuotedStringPosition: self currentPosition + 1.
	systemID := super nextSystemIDLiteral.
	driver handleEndQuotedStringPosition: self currentPosition.

	^ systemID.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 4/1/2017 19:49'!
nextSystemIDLiteralWithoutURIFragment
	| systemID |

	driver handleStartQuotedStringPosition: self currentPosition + 1.
	systemID := super nextSystemIDLiteralWithoutURIFragment.
	driver handleEndQuotedStringPosition: self currentPosition.

	^ systemID.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 3/19/2016 00:35'!
nextTag
	driver handleStartTagPosition: self currentPosition.
	super nextTag.
	driver handleEndTagPosition: self currentPosition.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/5/2017 06:02'!
nextXMLAttributeName: aName
	| startPosition |

	startPosition := self currentPosition + 1.
	driver handleStartQuotedStringNamePosition: startPosition.
	super nextXMLAttributeName: aName.
	driver handleEndQuotedStringNamePosition: startPosition + aName size - 1.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 3/19/2016 00:39'!
nextXMLDeclaration
	driver handleStartXMLDeclarationPosition: self currentPosition - 4. "'<?xml' size"
	super nextXMLDeclaration.
	driver handleEndXMLDeclarationPosition: self currentPosition.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/1/2017 19:49'!
nextXMLEncodingAttributeValue
	| encoding |

	driver handleStartQuotedStringPosition: self currentPosition + 1.
	encoding := super nextXMLEncodingAttributeValue.
	driver handleEndQuotedStringPosition: self currentPosition.

	^ encoding.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/1/2017 19:49'!
nextXMLStandaloneAttributeValue
	| yesOrNo |

	driver handleStartQuotedStringPosition: self currentPosition + 1.
	yesOrNo := super nextXMLStandaloneAttributeValue.
	driver handleEndQuotedStringPosition: self currentPosition.

	^ yesOrNo.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 4/1/2017 19:49'!
nextXMLVersionAttributeValue
	| version |

	driver handleStartQuotedStringPosition: self currentPosition + 1.
	version := super nextXMLVersionAttributeValue.
	driver handleEndQuotedStringPosition: self currentPosition.

	^ version.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'initialization' stamp: 'monty 9/29/2017 12:16'!
setDriver: aDriver stream: aStream readLimit: anInteger
	super
		setDriver: aDriver
		stream: aStream
		readLimit: anInteger.

	isInAttlistDeclaration := false.
	isInEntityReference := false.! !

!XMLOrderedList methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/1/2017 15:35'!
addOrderedListTableToComposite: aComposite paneTitle: aPaneTitle columnTitle: aColumnTitle
	"Adapted from SequenceableCollection>>gtInspectorItemsIn:"
	^ aComposite table
		title: aPaneTitle;
		display: [:aCollection |
			(1 to: self size) collect: [:i | i -> (self at: i)]];
		beMultiple;
		searchOn: [:text :each | 
			Behavior compilerClass
				evaluate: ' | entity each | each := self. entity := each.', text
				for: each value
				logged: false];
		column: 'Index' evaluated: [:assoc |
			self orderedListTableDisplayKeyFrom: assoc key];
		column: aColumnTitle evaluated: [:assoc |
			self orderedListTableDisplayValueFrom: assoc value];
		send: [:result |
			result ifNotNil: [
				result value size = 1 
					ifTrue: [result anyOne value]
					ifFalse: [
						self species withAll:
							(result collect: [:each | each value])]]];
		showOnly: 50;
		helpMessage:
			'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'! !

!XMLOrderedList methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/1/2017 15:31'!
gtInspectorItemsIn: aComposite
	^ self
		addOrderedListTableToComposite: aComposite
		paneTitle: 'Index'
		columnTitle: 'Item'! !

!XMLOrderedList methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/1/2017 15:35'!
orderedListTableDisplayKeyFrom: aKey
	^ aKey printString! !

!XMLOrderedList methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/1/2017 15:35'!
orderedListTableDisplayValueFrom: aValue
	"this may be overrided in the future in subclasses to return
	highlighted text objects when GT tables support it"
	^ aValue printString! !

GLMHighlighterTextStylerDecorator subclass: #GLMXMLHighlighterTextStylerDecorator
	instanceVariableNames: 'highlightableLengthLimit errorColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!GLMXMLHighlighterTextStylerDecorator commentStamp: 'monty 3/4/2017 13:05' prior: 0!
An abstract base class for XML highlighter text styler decorators. Subclasses need to implement #highlightingParse:onSuccess:onError: .!

GLMXMLHighlighterTextStylerDecorator subclass: #GLMXMLDocumentHighlighterTextStylerDecorator
	instanceVariableNames: 'encoding configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!GLMXMLDocumentHighlighterTextStylerDecorator commentStamp: 'monty 3/4/2017 13:05' prior: 0!
A highlighting XML document text style decorator.!

GLMXMLDocumentHighlighterTextStylerDecorator subclass: #GLMXMLDisabledDocumentHighlighterTextStylerDecorator
	instanceVariableNames: 'disabledText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!GLMXMLDisabledDocumentHighlighterTextStylerDecorator commentStamp: 'monty 3/31/2017 07:21' prior: 0!
A highlighting XML document text style decorator for disabled highlighting text presentations. The text and encoding are set at instance creation and can't be changed with editing.!

!GLMXMLDisabledDocumentHighlighterTextStylerDecorator class methodsFor: 'instance creation' stamp: 'monty 3/30/2017 16:32'!
disabledText: aStringOrText
	^ self
		disabledText: aStringOrText
		encoding: ''! !

!GLMXMLDisabledDocumentHighlighterTextStylerDecorator class methodsFor: 'instance creation' stamp: 'monty 3/30/2017 16:31'!
disabledText: aStringOrText encoding: anEncodingName
	^ self new
		disabledText: aStringOrText;
		encoding: anEncodingName! !

!GLMXMLDisabledDocumentHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 3/5/2017 15:49'!
disabledText
	^ disabledText ifNil: [disabledText := '' asText]! !

!GLMXMLDisabledDocumentHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 3/5/2017 15:49'!
disabledText: aStringOrText
	disabledText := aStringOrText asText! !

!GLMXMLDisabledDocumentHighlighterTextStylerDecorator methodsFor: 'parsing' stamp: 'monty 4/16/2017 12:53'!
highlightingParse: aString onError: aBlock
	^ self disabledText! !

!GLMXMLDocumentHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 4/17/2017 01:54'!
configuration
	^ configuration! !

!GLMXMLDocumentHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 4/17/2017 01:54'!
configuration: aConfiguration
	configuration := aConfiguration! !

!GLMXMLDocumentHighlighterTextStylerDecorator methodsFor: 'private' stamp: 'monty 4/16/2017 10:53'!
defaultEncoding
	^ ''! !

!GLMXMLDocumentHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 4/16/2017 10:49'!
encoding
	^ encoding! !

!GLMXMLDocumentHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 4/16/2017 10:49'!
encoding: anEncodingName
	encoding := anEncodingName! !

!GLMXMLDocumentHighlighterTextStylerDecorator methodsFor: 'testing' stamp: 'monty 4/21/2017 19:52'!
hasEncoding
	^ self encoding notEmpty! !

!GLMXMLDocumentHighlighterTextStylerDecorator methodsFor: 'parsing' stamp: 'monty 4/16/2017 14:51'!
highlightingParse: aString onError: aBlock
	| highlightingParserHandler highlightingParser |

	highlightingParserHandler :=
		self newHighlightingParserHandlerOn: aString.
	highlightingParser :=
		self newHighlightingParserFromHandler: highlightingParserHandler.
	[highlightingParser parseDocument]
		on: XMLParserException
		do: [:error |
			aBlock cull: error.
			self encoding: highlightingParserHandler encoding.
			^ highlightingParserHandler
				asHighlightedTextColored: self errorColor
				startingAt:
					(self
						highlightStartPositionForErrorAt:
							highlightingParser currentPosition
						in: aString)].
	self encoding: highlightingParserHandler encoding.
	^ highlightingParserHandler asHighlightedText.! !

!GLMXMLDocumentHighlighterTextStylerDecorator methodsFor: 'initialization' stamp: 'monty 4/16/2017 10:53'!
initialize
	super initialize.

	encoding := self defaultEncoding.! !

!GLMXMLDocumentHighlighterTextStylerDecorator methodsFor: 'private' stamp: 'monty 3/5/2017 15:43'!
newHighlightingParserFromHandler: aHighlightingParserHandler
	^ aHighlightingParserHandler parser! !

!GLMXMLDocumentHighlighterTextStylerDecorator methodsFor: 'private' stamp: 'monty 4/17/2017 02:06'!
newHighlightingParserHandlerOn: aString
	| parserHandler |

	parserHandler := XMLHighlightingParser on: aString.
	self configuration
		ifNotNil: [parserHandler configuration: self configuration copy].
	^ parserHandler.! !

!GLMXMLDocumentHighlighterTextStylerDecorator methodsFor: 'files' stamp: 'monty 4/21/2017 19:52'!
saveToFile: anXMLFileHandleOrFileName
	| sourceToSave streamConverter |

	sourceToSave := self text asString.
	streamConverter :=
		self hasEncoding
			ifTrue: [self encoding asXMLStreamConverter]
			ifFalse: [XMLStreamConverter default].
	anXMLFileHandleOrFileName asXMLFileHandle writeStreamDo: [:writeStream |
		writeStream
			streamConverter: streamConverter;
			nextPutByteOrderMark;
			nextPutAll: sourceToSave].! !

GLMXMLDocumentHighlighterTextStylerDecorator subclass: #GLMXMLOuterXMLDocumentHighlighterTextStylerDecorator
	instanceVariableNames: 'outerXMLNode document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!GLMXMLOuterXMLDocumentHighlighterTextStylerDecorator commentStamp: 'monty 3/31/2017 02:06' prior: 0!
A highlighting XML document text style decorator for editing the "outer" XML of a document or document node.!

!GLMXMLOuterXMLDocumentHighlighterTextStylerDecorator class methodsFor: 'private' stamp: 'monty 3/5/2017 15:43'!
outerXMLNode: aNode
	^ self new outerXMLNode: aNode! !

!GLMXMLOuterXMLDocumentHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 4/22/2017 05:13'!
document
	^ document! !

!GLMXMLOuterXMLDocumentHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 4/22/2017 05:13'!
document: aDocument
	document := aDocument! !

!GLMXMLOuterXMLDocumentHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 4/22/2017 05:12'!
encoding
	^ super encoding
		ifEmpty: [
			self document
				ifNil: ['']
				ifNotNil: [:node | node encoding]]! !

!GLMXMLOuterXMLDocumentHighlighterTextStylerDecorator methodsFor: 'private' stamp: 'monty 10/6/2017 14:16'!
newHighlightingParserFromHandler: aHighlightingParserHandler
	| parser rootElement |

	parser := super newHighlightingParserFromHandler: aHighlightingParserHandler.

	self document
		ifNotNil: [
			parser driver isStandalone: self document isStandalone.
			self document hasDoctypeDefinition
				ifTrue: [
					parser driver doctypeDefinition
						addGeneralEntitiesFrom: self document doctypeDefinition]].

	self outerXMLNode isElement
		ifTrue: [rootElement := self outerXMLNode]
		ifFalse: [
			(self outerXMLNode hasParent
				and: [self outerXMLNode parent isElement])
				ifTrue: [rootElement := self outerXMLNode parent]].
	rootElement
		ifNotNil: [
			parser driver currentElement: rootElement name.
			rootElement hasNamespaces
				ifTrue: [parser driver currentScope: rootElement namespaceScope]].

	parser state: self outerXMLNode parent newInnerXMLState.
	parser state isContentState
		ifTrue: [aHighlightingParserHandler startContent].

	^ parser.! !

!GLMXMLOuterXMLDocumentHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 3/5/2017 15:43'!
outerXMLNode
	^ outerXMLNode! !

!GLMXMLOuterXMLDocumentHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 9/17/2017 03:30'!
outerXMLNode: aNode
	outerXMLNode := aNode.
	"the document is saved because this node will be replaced and removed
	from it when the edited source is accepted, and the encoding is needed
	from it if the source is being saved to a file"
	self
		configuration: aNode configuration;
		document: aNode document! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 4/16/2017 10:49'!
defaultErrorColor
	^ TextColor red! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 4/16/2017 10:55'!
defaultHighlightableLengthLimit
	^ 100000! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 10/1/2015 21:52'!
defaultStyler
	^ GLMHighlighterTextParserStyler new
		view: self;
		parser: self! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 10/3/2015 02:11'!
errorColor
	^ errorColor! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 10/3/2015 02:12'!
errorColor: aTextColor
	errorColor := aTextColor! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'private' stamp: 'monty 4/16/2017 15:08'!
highlightStartPositionForErrorAt: aPosition in: aString
	"color all of it if the error occurred at the end of the
	input, otherwise there would be no error coloring at all"
	^ aPosition >= aString size
		ifTrue: [1]
		ifFalse: [aPosition]! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 10/3/2015 02:11'!
highlightableLengthLimit
	^ highlightableLengthLimit! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 9/29/2017 12:09'!
highlightableLengthLimit: anInteger
	highlightableLengthLimit := anInteger! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'parsing' stamp: 'monty 4/16/2017 12:36'!
highlightingParse: aString onError: aBlock
	self subclassResponsibility! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'initialization' stamp: 'monty 4/16/2017 10:50'!
initialize
	super initialize.

	highlightableLengthLimit := self defaultHighlightableLengthLimit.
	errorColor := self defaultErrorColor.! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'parsing' stamp: 'monty 4/16/2017 12:40'!
parse: aString onError: aBlock
	aString size <= self highlightableLengthLimit
		ifTrue: [
			^ self
				highlightingParse: aString
				onError: aBlock]
		ifFalse: [^ self text]! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'parsing' stamp: 'monty 10/1/2015 21:54'!
parser
	^ self! !

SAXHandler subclass: #SAXPositionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!SAXPositionHandler commentStamp: 'monty 10/2/2015 04:56' prior: 0!
This class is a SAXHandler that can track the positions of tokens. Does not support validation or entity replacement but can check wellformedness and namespaces.!

!SAXPositionHandler methodsFor: 'defaults' stamp: 'monty 10/1/2015 04:26'!
driverClass
	^ SAXPositionParserDriver! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:44'!
endCDataPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
endCommentPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:46'!
endDeclarationPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:33'!
endDoctypeDeclarationPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:32'!
endEntityReferencePosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 4/5/2017 05:44'!
endNamePosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:31'!
endPIPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 4/5/2017 05:44'!
endQuotedStringNamePosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 4/1/2017 19:49'!
endQuotedStringPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:27'!
endTagPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:27'!
endXMLDeclarationPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:43'!
startCDataPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
startCommentPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:46'!
startDeclarationPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:33'!
startDoctypeDeclarationPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:32'!
startEntityReferencePosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 4/5/2017 05:44'!
startNamePosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:31'!
startPIPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 4/5/2017 05:44'!
startQuotedStringNamePosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 4/1/2017 19:49'!
startQuotedStringPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:26'!
startTagPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:26'!
startXMLDeclarationPosition: aPosition! !

SAXPositionHandler subclass: #XMLHighlightingParser
	instanceVariableNames: 'highlighter encoding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!XMLHighlightingParser commentStamp: 'monty 3/6/2016 08:22' prior: 0!
This class is an XML parser that can convert its input to Text objects styled with highlighting after parsing.!

!XMLHighlightingParser methodsFor: 'converting' stamp: 'monty 3/1/2017 18:32'!
asHighlightedText
	| text |

	text := self input asString asText.
	highlighter highlightText: text.
	^ text.! !

!XMLHighlightingParser methodsFor: 'converting' stamp: 'monty 4/16/2017 11:13'!
asHighlightedTextColored: aTextColor startingAt: aPosition
	| text |

	text := self asHighlightedText.
	highlighter
		highlightText: text
		withColor: aTextColor
		startingAt: aPosition.
	^ text.! !

!XMLHighlightingParser methodsFor: 'accessing' stamp: 'monty 3/5/2016 07:09'!
encoding
	^ encoding! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endCDataPosition: aPosition
	highlighter endCDataHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endCommentPosition: aPosition
	highlighter endCommentHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endDeclarationPosition: aPosition
	highlighter endDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endDoctypeDeclarationPosition: aPosition
	highlighter endDoctypeDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endEntityReferencePosition: aPosition
	highlighter endEntityReferenceHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 4/5/2017 06:09'!
endNamePosition: aPosition
	highlighter endNameHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endPIPosition: aPosition
	highlighter endPIHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 4/5/2017 06:09'!
endQuotedStringNamePosition: aPosition
	highlighter endQuotedStringNameHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 4/1/2017 19:50'!
endQuotedStringPosition: aPosition
	highlighter endQuotedStringHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endTagPosition: aPosition
	highlighter endTagHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endXMLDeclarationPosition: aPosition
	highlighter endXMLDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'accessing' stamp: 'monty 10/1/2015 04:50'!
highlighter
	^ highlighter! !

!XMLHighlightingParser methodsFor: 'initialization' stamp: 'monty 2/27/2017 17:19'!
on: aStringOrStream
	super on: aStringOrStream.

	highlighter := XMLDocumentHighlighter new.
	encoding := ''.! !

!XMLHighlightingParser methodsFor: 'parsing' stamp: 'monty 10/1/2015 22:22'!
parsingResult
	^ self asHighlightedText! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:43'!
startCDataPosition: aPosition
	highlighter startCDataHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:47'!
startCommentPosition: aPosition
	highlighter startCommentHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:44'!
startDeclarationPosition: aPosition
	highlighter startDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:46'!
startDoctypeDeclarationPosition: aPosition
	highlighter startDoctypeDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:48'!
startEntityReferencePosition: aPosition
	highlighter startEntityReferenceHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 4/5/2017 06:08'!
startNamePosition: aPosition
	highlighter startNameHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:47'!
startPIPosition: aPosition
	highlighter startPIHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 4/5/2017 06:09'!
startQuotedStringNamePosition: aPosition
	highlighter startQuotedStringNameHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 4/1/2017 19:50'!
startQuotedStringPosition: aPosition
	highlighter startQuotedStringHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:48'!
startTagPosition: aPosition
	highlighter startTagHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:46'!
startXMLDeclarationPosition: aPosition
	highlighter startXMLDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - lexical' stamp: 'monty 3/5/2016 07:09'!
xmlVersion: aVersionFloat encoding: anEncoding standalone: aBoolean
	encoding := anEncoding! !

!XMLNodeWithChildren methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/26/2017 22:46'!
addTreeViewChildrenTo: anOrderedCollection
	self nodesDo: [:each |
		anOrderedCollection addLast: each]! !

!XMLNodeWithChildren methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/26/2017 21:54'!
supportsTreeView
	^ self hasChildren! !

!XMLNodeWithChildren methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/26/2017 21:54'!
treeViewChildren
	self supportsTreeView
		ifTrue: [| treeViewChildren |
			treeViewChildren := OrderedCollection new: self nodes size.
			self addTreeViewChildrenTo: treeViewChildren.
			^ treeViewChildren]
		ifFalse: [^ #()]! !

XMLPrologPrettyPrintingWriterFormatter subclass: #XMLHighlightingPrologPrettyPrintingWriterFormatter
	instanceVariableNames: 'highlighter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Writer'!

!XMLHighlightingPrologPrettyPrintingWriterFormatter commentStamp: 'monty 3/31/2017 02:07' prior: 0!
This formatter adds highlights to prolog pretty printed XMLHighlightingWriter output.

(Generated from XMLHighlightingWriterFormatter.)!

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'private' stamp: 'monty 4/5/2017 06:23'!
endPosition
	^ self writer position! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterCData: aCDataWriter
	highlighter endCDataHighlightPosition: self endPosition.

	super formatAfterCData: aCDataWriter.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterCharacterEscape: aCharacterEscape
	highlighter endEntityReferenceHighlightPosition: self endPosition.

	super formatAfterCharacterEscape: aCharacterEscape.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterComment: aCommentWriter
	highlighter endCommentHighlightPosition: self endPosition.

	super formatAfterComment: aCommentWriter.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterDeclaration: aDeclarationWriter
	highlighter endDeclarationHighlightPosition: self endPosition.

	super formatAfterDeclaration: aDeclarationWriter.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter
	highlighter endDoctypeDeclarationHighlightPosition: self endPosition.

	super formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterEndTag: aTagWriter
	highlighter endTagHighlightPosition: self endPosition.

	super formatAfterEndTag: aTagWriter.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterEntityReference: anEntityReferenceWriter
	highlighter endEntityReferenceHighlightPosition: self endPosition.

	super formatAfterEntityReference: anEntityReferenceWriter.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterName: aName
	highlighter endNameHighlightPosition: self endPosition.

	super formatAfterName: aName.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterPI: aPIWriter
	highlighter endPIHighlightPosition: self endPosition.

	super formatAfterPI: aPIWriter.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterQuotedStringName: aName
	highlighter endQuotedStringNameHighlightPosition: self endPosition.

	super formatAfterQuotedStringName: aName.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterQuotedStringValue: aString
	highlighter endQuotedStringHighlightPosition: self endPosition + 1.

	super formatAfterQuotedStringValue: aString.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterStartTag: aTagWriter
	highlighter endTagHighlightPosition: self endPosition.

	super formatAfterStartTag: aTagWriter.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatAfterXMLDeclaration: anXMLDeclarationWriter
	highlighter endXMLDeclarationHighlightPosition: self endPosition.

	super formatAfterXMLDeclaration: anXMLDeclarationWriter.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeCData: aCDataWriter
	super formatBeforeCData: aCDataWriter.

	highlighter startCDataHighlightPosition: self startPosition.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeCharacterEscape: aCharacterEscape
	super formatBeforeCharacterEscape: aCharacterEscape.

	highlighter startEntityReferenceHighlightPosition: self startPosition.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeComment: aCommentWriter
	super formatBeforeComment: aCommentWriter.

	highlighter startCommentHighlightPosition: self startPosition.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeDeclaration: aDeclarationWriter
	super formatBeforeDeclaration: aDeclarationWriter.

	highlighter startDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter
	super formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter.

	highlighter startDoctypeDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeEndTag: aTagWriter
	super formatBeforeEndTag: aTagWriter.

	highlighter startTagHighlightPosition: self startPosition.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeEntityReference: anEntityReferenceWriter
	super formatBeforeEntityReference: anEntityReferenceWriter.

	highlighter startEntityReferenceHighlightPosition: self startPosition.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeName: aName
	highlighter startNameHighlightPosition: self startPosition.

	super formatBeforeName: aName.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforePI: aPIWriter
	super formatBeforePI: aPIWriter.

	highlighter startPIHighlightPosition: self startPosition.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeQuotedStringName: aName
	highlighter startQuotedStringNameHighlightPosition: self startPosition.

	super formatBeforeQuotedStringName: aName.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeQuotedStringValue: aString
	super formatBeforeQuotedStringValue: aString.

	highlighter startQuotedStringHighlightPosition: self startPosition - 1.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeStartTag: aTagWriter
	super formatBeforeStartTag: aTagWriter.

	highlighter startTagHighlightPosition: self startPosition.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 4/5/2017 06:23'!
formatBeforeXMLDeclaration: anXMLDeclarationWriter
	super formatBeforeXMLDeclaration: anXMLDeclarationWriter.

	highlighter startXMLDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'private' stamp: 'monty 4/5/2017 06:23'!
startPosition
	^ self writer position + 1! !

!XMLHighlightingPrologPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 4/5/2017 06:23'!
writer: aWriter
	super writer: aWriter.

	highlighter := aWriter highlighter.! !

!XMLInternalSubsetList methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/13/2015 13:19'!
gtInspectorItemsIn: aComposite
	^ self
		addOrderedListTableToComposite: aComposite
		paneTitle: 'Nodes'
		columnTitle: 'Node'! !

!XMLDoctypeDeclaration methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/27/2017 00:44'!
removeFromParent
	self parent doctypeDeclaration: nil! !

!XMLDoctypeDeclaration methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/7/2017 09:29'!
supportsSourceEditing
	^ false! !

!XMLDoctypeDeclaration methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/7/2017 13:31'!
writeTreeViewLabelXMLOn: aWriter
	aWriter doctype
		root: self root;
		publicID: self publicID;
		systemID: self systemID;
		write! !

XMLHighlightDefaults initialize!
